Subject: Re: Restart Signaling for IS-IS (draft-ietf-isis-restart-04.txt)

From: Acee Lindem <[email-masked]>
Date: Tue, 04 Nov 2003 14:35:43 -0500

Hi Les,

(Copying rtg-dir since I guess all review comments are to go there).

Les Ginsberg wrote:

> Acee -
>
> It appears that you are looking at V4 of the draft, which is the last 
> one that was posted. However, we prepared V5 of the draft which is 
> purely an editorial revision precisely to address the "nits". It also 
> includes some minor changes regarding SA bit handling by the receiver 
> that were requested by Tony P. in his review. Apparently no one 
> forwarded V5 to you (it has not been publicly posted yet). I have 
> attached it. (Apologies to those who already have it.)
>
> Some more responses below.
>
>
> At 05:11 PM 11/3/2003 -0500, Acee Lindem wrote:
>
>> Les, Mike,
>>
>> As members of the routing directorate, Chris and I are reviewing the 
>> subject document. It has
>> been years since I've read the base IS-IS specifications so please 
>> bear with my questions.
>>
>> First Nits:
>>
>>   - Abstracts are not supposed to contain any [] references since 
>> they are often excerpted.  You'll
>>     need to reference the base documents by name.
>>   - Section 4.3.1. Replace "IIH w RR" with "IIH with RR".
>
>
> Will do (though this is now Section 3.4.1).
>
>> Comments/Questions:
>>
>>     1. Graceful restart does not appear to be terminated when a 
>> neighbor not implementing the
>>         extensions is detected by the restarting router - couldn't 
>> this potentially cause a routing
>>         loop? For OSPF, the restarting router will terminate graceful 
>> restart in this case.
>
>
> I don't think so - at least not persistent ones. In order for a loop 
> to occur, a router would have to compute a path via a non-restart 
> capable(legacy) neighbor of the restarting router that transited the 
> restarting router (either on its way to the legacy router or after 
> reaching the legacy router). Since the legacy router will quickly 
> announce the loss of adjacency to the restarting router, two way 
> connectivity check should guarantee that this loop won't persist. Once 
> the adjacency comes back up, the topology has now been restored to its 
> pre-restart state - which is what has been preserved in the restarting 
> router's forwarding plane.
>
> Have I missed something? 

I think this is correct. I can't come up with a case where a loop would 
persist as long as the router
not supporting these extensions does not advertise the adjacency.

>
>
>
>>     2. Prior to the SA bit, wasn't there any way for an adjacent 
>> neighbor to learn its neighbor
>>         had lost synchronization?  I looked at IOS 9542 and didn't 
>> find anything.
>
>
> Well, 9542 wouldn't help you, as that is the ES-IS spec. It's ISO 
> 10589:2002 that is relevant here. Unlike OSPF, IS-IS never required 
> database synchronization before advertising a neighbor - only that the 
> adjacency reach UP state which only requires hello exchange. 
> Subsequent to that database synchronization occurred. See 7.3.7 and 
> the state tables in Section 8.
>
> I am not sure what you mean here by "lost synchronization". The SA bit 
> is used to suppress neighbor advertisement until synchronization has 
> been achieved. It's not used to respond to lost synchronization. 

Ok - that makes sense if advertisement and mutual agreement on database 
synchronization aren't required for advertisement.
The purpose of the SA bit is avoid waiting for a restarting router to 
flooding it's LSPs. However, wouldn't this happen
immediately if an ISIS router is not restarting gracefully?

>
>
>    Les
>
>
>> Thanks,
>> Acee
>>
>------------------------------------------------------------------------
>
>
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
> 
>Network Working Group                                          M. Shand 
>Internet Draft                                              L. Ginsberg 
>Expiration Date: April 2004                               Cisco Systems 
>                                                           October 2003 
>                                                                        
>                                                                        
>                                                                        
>                                                                        
>                                                                        
> 
>                      Restart signaling for IS-IS 
>                     draft-ietf-isis-restart-05.txt 
> 
> 
>Status of this Memo 
>    
>
>   This document is an Internet-Draft and is in full conformance with 
>   all provisions of Section 10 of RFC 2026.  
>
>   Internet-Drafts are working documents of the Internet Engineering 
>   Task Force (IETF), its areas, and its working groups. Note that 
>   other groups may also distribute working documents as Internet-
>   Drafts. Internet-Drafts are draft documents valid for a maximum of 
>   six months and may be updated, replaced, or obsoleted by other 
>   documents at any time. It is inappropriate to use Internet-Drafts as 
>   reference material or to cite them other than as "work in progress." 
>
>   The list of current Internet-Drafts can be accessed at 
>   http://www.ietf.org/ietf/1id-abstracts.txt.  
>
>   The list of Internet-Draft Shadow Directories can be accessed at 
>   http://www.ietf.org/shadow.html. 
>
>   Copyright Notice Copyright (C) The Internet Society (2003). All  
>   Rights Reserved. 
>
>Abstract 
>    
>
>   The IS-IS routing protocol (RFC 1195, ISO/IEC 10589) is a link state 
>   intra-domain routing protocol. Normally, when an IS-IS router is 
>   restarted, temporary disruption of routing occurs due to events in 
>   both the restarting router and the neighbors of the restarting 
>   router. 
>
>   The router which has been restarted computes its own routes before 
>   achieving database synchronization with its neighbors. The results 
>
> 
>  
>Shand, Ginsberg            Expires Apr 2004                   [Page 1] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>   of this computation are likely to be non-convergent with the routes 
>   computed by other routers in the area/domain. 
>
>   Neighbors of the restarting router detect the restart event and 
>   cycle their adjacencies with the restarting router through the down 
>   state. The cycling of the adjacency state causes the neighbors to 
>   regenerate their LSPs describing the adjacency concerned. This in 
>   turn causes temporary disruption of routes passing through the 
>   restarting router. 
>
>   In certain scenarios the temporary disruption of the routes is 
>   highly undesirable. This draft describes mechanisms to avoid or 
>   minimize the disruption due to both of these causes. 
>
>Table of Contents 
>    
>
>   1. Conventions used in this document..............................2 
>   2. Overview.......................................................3 
>   3. Approach.......................................................4 
>    3.1 Timers.......................................................4 
>    3.2 Restart TLV..................................................4 
>     3.2.1 Use of RR and RA bits.....................................5 
>     3.2.2 Use of SA bit.............................................7 
>    3.3 Adjacency (re)acquisition....................................7 
>     3.3.1 Adjacency reacquisition during restart....................7 
>     3.3.2 Adjacency acquisition during start.......................10 
>     3.3.3 Multiple levels..........................................11 
>    3.4 Database synchronization....................................11 
>     3.4.1 LSP generation and flooding and SPF computation..........12 
>   4. State Tables..................................................15 
>    4.1 Running Router..............................................15 
>    4.2 Restarting Router...........................................16 
>    4.3 Starting Router.............................................17 
>   5. Security Considerations.......................................18 
>   6. Normative References..........................................18 
>   7. Acknowledgments...............................................18 
>   8. Authors' Addresses............................................18 
>   9. Full Copyright Statement......................................19 
>    
>1.    Conventions used in this document 
>
>   The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", 
>   "SHOULD", "SHOULD NOT", "RECOMMENDED",  "MAY", and "OPTIONAL" in 
>   this document are to be interpreted as described in RFC-2119 [4]. 
>
>
> 
> 
>Shand, Ginsberg            Expires Apr 2004                   [Page 2] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>   If the control and forwarding functions in a router can be 
>   maintained independently, it is possible for the forwarding function 
>   state to be maintained across a control function restart. This 
>   functionality is assumed when the terms "restart/restarting" are 
>   used in this document. 
>
>   The terms "start/starting" are used to refer to a router in which 
>   the control function has either been started for the first time or 
>   has been restarted but the forwarding functions have not been 
>   maintained in a prior state. 
>
>   The terms "(re)start/(re)starting" are used when the text is 
>   applicable to both a "starting" and a "restarting" router. 
>
>2.    Overview 
>
>   When an adjacency is reinitialized as a result of a neighbor 
>   (re)starting, a router does three things: 
>
>      1. It causes its own LSP(s) to be regenerated, thus triggering 
>        SPF runs throughout the area (or in the case of Level 2, 
>        throughout the domain). 
>
>      2. It sets SRMflags on its own LSP database on the adjacency 
>        concerned. 
>
>      3. In the case of a Point-to-Point link it transmits a complete 
>        set of CSNP(s) over the adjacency. 
>
>   In the case of a restarting router process, the first of these is 
>   highly undesirable, but the second is essential in order to ensure 
>   synchronization of the LSP database. 
>
>   The third action above minimizes the number of LSPs which must be 
>   exchanged and, if made reliable, provides a means of determining 
>   when the LSP databases of the neighboring routers have been 
>   synchronized. This is desirable whether the router is being 
>   restarted or not (so that the overload bit can be cleared in the 
>   router's own LSP, for example). 
>
>   This draft describes a mechanism for a restarting router to signal 
>   that it is restarting to its neighbors, and allow them to 
>   reestablish their adjacencies without cycling through the down 
>   state, while still correctly initiating database synchronization. 
>
>   This draft additionally describes a mechanism for a restarting 
>   router to determine when it has achieved LSP database 
>   synchronization with its neighbors. 
>
>
> 
> 
>Shand, Ginsberg            Expires Apr 2004                   [Page 3] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>   This draft additionally describes a mechanism to optimize LSP 
>   database synchronization and minimize transient routing disruption 
>   when a router starts. 
>
>   It is assumed that the three-way handshake [5] is being used on 
>   Point-to-Point circuits. 
>
>3.    Approach 
>
>3.1     Timers 
>
>   Three additional timers, T1, T2 and T3 are required to support the 
>   functionality defined in this document. 
>
>   An instance of the timer T1 is maintained per interface, and 
>   indicates the time after which an unacknowledged (re)start attempt 
>   will be repeated. A typical value might be 3 seconds. 
>
>   An instance of the timer T2 is maintained for each LSP database 
>   present in the system i.e. for a Level1/2 system, there will be an 
>   instance of the timer T2 for Level 1 and an instance for Level 2. 
>   This is the maximum time that the system will wait for LSPDB 
>   synchronization. A typical value might be 60 seconds. 
>
>   A single instance of the timer T3 is maintained for the entire 
>   system. It indicates the time after which the router will declare 
>   that it has failed to achieve database synchronization (by setting 
>   the overload bit in its own LSP). This is initialized to 65535 
>   seconds, but is set to the minimum of the remaining times of 
>   received IIHs containing a restart TLV with RA set and an indication 
>   that the neighbor has an adjacency in the UP state to the restarting 
>   router. 
>
>   NOTE: The timer T3 is only used by a restarting router. 
>
>3.2     Restart TLV 
>
>   A new TLV is defined to be included in IIH PDUs. The presence of 
>   this TLV indicates that the sender supports the functionality 
>   defined in this document and it carries flags that are used to 
>   convey information during a (re)start. All IIHs transmitted by a 
>   router that supports this capability MUST include this TLV.  
>
>         Type   211 
>         Length 1 - (3 + ID Length) 
>         Value  
>           Flags (1 octet) 
>
>
>
> 
> 
>Shand, Ginsberg            Expires Apr 2004                   [Page 4] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>              0  1  2  3  4  5  6  7 
>             +--+--+--+--+--+--+--+--+ 
>             |  Reserved    |SA|RA|RR| 
>             +--+--+--+--+--+--+--+--+ 
>              
>
>             RR - Restart Request 
>             RA - Restart Acknowledgment 
>             SA - Suppress adjacency advertisement 
>              
>
>           (Note: Remaining fields are required when RA bit is set) 
>
>           Remaining Time (2 octets) 
>
>             Remaining holding time (in seconds) 
>              
>
>           Restarting Neighbor System ID (ID Length octets) 
>
>             The system ID of the neighbor to which the RA refers. 
>             Note: Implementations based on earlier versions of this 
>             document may not include this field in the TLV when RA is 
>             set. In this case a router which is expecting an RA on a 
>             LAN circuit SHOULD assume that the acknowledgement is 
>             directed at the local system.) 
>              
>              
>3.2.1       Use of RR and RA bits 
>
>   The RR bit is used by a (re)starting router to signal to its 
>   neighbors that a (re)start is in progress, that an existing 
>   adjacency SHOULD be maintained even under circumstances when the 
>   normal operation of the adjacency state machine would require the 
>   adjacency to be reinitialized, to request a set of CSNPs, and to 
>   request setting of SRMflags. 
>
>   The RA bit is sent by the neighbor of a (re)starting router to 
>   acknowledge the receipt of a restart TLV with the RR bit set. 
>
>   When the neighbor of a (re)starting router receives an IIH with the 
>   restart TLV having the RR bit set, if there exists on this interface 
>   an adjacency in state "Up" with the same System ID, and in the case 
>   of a LAN circuit, with the same source LAN address, then, 
>   irrespective of the other contents of the "Intermediate System 
>   Neighbors" option (LAN circuits), or the "Point-to-Point Three-Way 
>   Adjacency" option (Point-to-Point circuits):   
>
>
> 
> 
>Shand, Ginsberg            Expires Apr 2004                   [Page 5] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>    a) The state of the adjacency is not changed. If this is the first 
>      IIH with the RR bit set that this system has received associated 
>      with this adjacency then the adjacency is marked as being in 
>      "Restart mode" and the adjacency holding time is refreshed - 
>      otherwise the holding time is not refreshed. The "remaining time" 
>      transmitted according to (b) below MUST reflect the actual time 
>      after which the adjacency will now expire. Receipt of a normal 
>      IIH with RR bit reset will clear the "Restart mode" state. This 
>      procedure allows the restarting router to cause the neighbor to 
>      maintain the adjacency long enough for restart to successfully 
>      complete while also preventing repetitive restarts from 
>      maintaining an adjacency indefinitely. Whether an adjacency is 
>      marked as being in "Restart mode" or not has no effect on 
>      adjacency state transitions. 
>
>    b) immediately (i.e. without waiting for any currently running timer 
>      interval to expire, but with a small random delay of a few 10s of 
>      milliseconds on LANs to avoid "storms"), transmit over the 
>      corresponding interface an IIH including the restart TLV with the 
>      RR bit clear and the RA bit set, in the case of Point-to-Point 
>      adjacencies having updated the "Point-to-Point Three-Way 
>      Adjacency" option to reflect any new values received from the 
>      (re)starting router. (This allows a restarting router to quickly 
>      acquire the correct information to place in its hellos.) The 
>      "Remaining Time" MUST be set to the current time (in seconds) 
>      before the holding timer on this adjacency is due to expire. If 
>      the corresponding interface is a LAN interface, then the 
>      Restarting Neighbor System ID SHOULD be set to the System ID of 
>      the router from whom the IIH with RR bit set was received. This 
>      is required to correctly associate the acknowledgement and 
>      holding time in the case where multiple systems on a LAN restart 
>      at approximately the same time. This IIH SHOULD be transmitted 
>      before any LSPs or SNPs transmitted as a result of the receipt of 
>      the original IIH. 
>
>    c) if the corresponding interface is a Point-to-Point interface, or 
>      if the receiving router has the highest LnRouterPriority (with 
>      highest source MAC address breaking ties) among those routers to 
>      which the receiving router has an adjacency in state "Up" on this 
>      interface whose IIHs contain the restart TLV, excluding 
>      adjacencies to all routers which are considered in "Restart mode" 
>      (note the actual DIS is NOT changed by this process), initiate 
>      the transmission over the corresponding interface of a complete 
>      set of CSNPs, and set SRMflags on the corresponding interface for 
>      all LSPs in the local LSP database. 
>
>   Otherwise (i.e. if there was no adjacency in the "UP" state to the 
>   system ID in question), process the IIH as normal by reinitializing 
>   the adjacency, and setting the RA bit in the returned IIH. 
>
> 
> 
>Shand, Ginsberg            Expires Apr 2004                   [Page 6] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>3.2.2       Use of SA bit 
>
>   The SA bit is used by a starting router to request that its neighbor 
>   suppress advertisement of the adjacency to the starting router in 
>   the neighbor's LSPs. 
>
>   A router which is starting has no maintained forwarding function 
>   state. This may or may not be the first time the router has started. 
>   If this is not the first time the router has started, copies of LSPs 
>   generated by this router in its previous incarnation may exist in 
>   the LSP databases of other routers in the network. These copies are 
>   likely to appear "newer" than LSPs initially generated by the 
>   starting router due to the reinitialization of LSP fragment sequence 
>   numbers by the starting router. This may cause temporary blackholes 
>   to occur until the normal operation of the update process causes the 
>   starting router to regenerate and flood copies of its own LSPs with 
>   higher sequence numbers. The temporary blackholes can be avoided if 
>   the starting router's neighbors suppress advertising an adjacency to 
>   the starting router until the starting router has been able to 
>   propagate newer versions of LSPs generated by previous incarnations. 
>
>   When a router receives an IIH with the restart TLV having the SA bit 
>   set, if there exists on this interface an adjacency in state "Up" 
>   with the same System ID, and in the case of a LAN circuit, with the 
>   same source LAN address, then advertisement of the adjacency to the 
>   neighbor in LSPs MUST be suppressed. Until an IIH with the SA bit 
>   clear has been received, the neighbor advertisement MUST continue to 
>   be suppressed. If the adjacency transitions to the UP state, the new 
>   adjacency MUST NOT be advertised until an IIH with the SA bit clear 
>   has been received. 
>
>   Note that a router which suppresses advertisement of an adjacency  
>   MUST NOT use this adjacency when performing its SPF calculation. In 
>   particular, if an implementation follows the example guidelines 
>   presented in [3] Annex C.2.5 Step 0:b) "pre-load TENT with the local 
>   adjacency database", the suppressed adjacency MUST NOT be loaded 
>   into TENT. 
>
>3.3     Adjacency (re)acquisition 
>
>   Adjacency (re)acquisition is the first step in (re)initialization. 
>   Restarting and starting routers will make use of the RR bit in the 
>   restart TLV, though each will use it at different stages of the 
>   (re)start procedure.  
>
>3.3.1       Adjacency reacquisition during restart 
>
>   The restarting router explicitly notifies its neighbor that the 
>   adjacency is being reacquired, and hence that it SHOULD NOT 
>   reinitialize the adjacency. This is achieved by setting the RR bit 
> 
> 
>Shand, Ginsberg            Expires Apr 2004                   [Page 7] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>   in the restart TLV. When the neighbor of a restarting router 
>   receives an IIH with the restart TLV having the RR bit set, if there 
>   exists on this interface an adjacency in state "Up" with the same 
>   System ID, and in the case of a LAN circuit, with the same source 
>   LAN address, then the procedures described in 4.2.1 are followed. 
>
>   A router that does not support the restart capability will ignore 
>   the restart TLV and reinitialize the adjacency as normal, returning 
>   an IIH without the restart TLV. 
>
>   On restarting, a router initializes the timer T3, starts the timer 
>   T2 for each LSPDB and for each interface (and in the case of a LAN 
>   circuit, for each level) starts the timer T1 and transmits an IIH 
>   containing the restart TLV with the RR bit set. 
>
>   On a Point-to-Point circuit the "Adjacency Three-Way State" SHOULD 
>   be set to "Init", because the receipt of the acknowledging IIH (with 
>   RA set) MUST cause the adjacency to enter "Up" state immediately. 
>
>   On a LAN circuit the LAN-ID assigned to the circuit SHOULD be the 
>   same as that used prior to the restart. In particular, for any 
>   circuits for which the restarting router was previously DIS, the use 
>   of a different LAN-ID would necessitate the generation of a new set 
>   of pseudonode LSPs, and corresponding changes in all the LSPs 
>   referencing them from other routers on the LAN. By preserving the 
>   LAN-ID across the restart, this churn can be prevented. To enable a 
>   restarting router to learn the LAN-ID used prior to restart, the 
>   LAN-ID specified in an IIH w RR set MUST be ignored. 
>
>   Transmission of "normal" IIHs is inhibited until the conditions 
>   described below are met (in order to avoid causing an unnecessary 
>   adjacency initialization). On expiry of the timer T1, it is 
>   restarted and the IIH is retransmitted as above. 
>
>   When a restarting router receives an IIH a local adjacency is 
>   established as usual, and if the IIH contains a restart TLV with the 
>   RA bit set (and on LAN circuits with a Restart Neighbor System ID 
>   which matches that of the local system), the receipt of the 
>   acknowledgement over that interface is noted. When the RA bit is set 
>   and the state of the remote adjacency is UP then the timer T3 is set 
>   to the minimum of its current value and the value of the "Remaining 
>   Time" field in the received IIH.  
>
>   On a Point-to-Point link, receipt of an IIH not containing the 
>   restart TLV is also treated as an acknowledgement, since it 
>   indicates that the neighbor is not restart capable. However, since 
>   no CSNP is guaranteed to be received over this interface, the timer 
>   T1 is cancelled immediately without waiting for a complete set of 
>   CSNP(s). Synchronization may therefore be deemed complete even 
>   though there are some LSPs which are held (only) by this neighbor 
> 
> 
>Shand, Ginsberg            Expires Apr 2004                   [Page 8] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>   (see section 4.4). In this case we also want to be certain that the 
>   neighbor will reinitialize the adjacency in order to guarantee that 
>   SRMflags have been set on its database, thus ensuring eventual LSPDB 
>   synchronization. This is guaranteed to happen except in the case 
>   where the Adjacency Three-Way State in the received IIH is UP and 
>   the Neighbor Extended Local Circuit ID matches the extended local 
>   circuit ID assigned by the restarting router. In this case the 
>   restarting router MUST force the adjacency to reinitialize by 
>   setting the local Adjacency Three-Way State to DOWN and sending a 
>   normal IIH.  
>
>   In the case of a LAN interface, receipt of an IIH not containing the 
>   restart TLV is unremarkable since synchronization can still occur so 
>   long as at least one of the non-restarting neighboring routers on 
>   the LAN supports restart. Therefore T1 continues to run in this 
>   case. If none of the neighbors on the LAN are restart capable, T1 
>   will eventually expire after the locally defined number of retries.  
>
>   In the case of a Point-to-Point circuit, the "LocalCircuitID" and 
>   "Extended Local Circuit ID" information contained in the IIH can be 
>   used immediately to generate an IIH containing the correct 3-way 
>   handshake information. The presence of "Neighbor Extended Local 
>   Circuit ID" information which does not match the value currently in 
>   use by the local system is ignored (since the IIH may have been 
>   transmitted before the neighbor had received the new value from the 
>   restarting router), but the adjacency remains in the initializing 
>   state until the correct information is received. 
>
>   In the case of a LAN circuit the source neighbor information (e.g. 
>   SNPAAddress) is recorded and used for adjacency establishment and 
>   maintenance as normal. 
>
>   When BOTH a complete set of CSNP(s) (for each active level, in the 
>   case of a pt-pt circuit) and an acknowledgement have been received 
>   over the interface, the timer T1 is cancelled. 
>
>   Once the timer T3 has expired or been cancelled, subsequent IIHs are 
>   transmitted according to the normal algorithms, but including the 
>   restart TLV with both RR and RA clear. 
>
>   If a LAN contains a mixture of systems, only some of which support 
>   the new algorithm, database synchronization is still guaranteed, but 
>   the "old" systems will have reinitialized their adjacencies. 
>
>   If an interface is active, but does not have any neighboring router 
>   reachable over that interface the timer T1 would never be cancelled, 
>   and according to clause 3.4.1.1 the SPF would never be run. 
>   Therefore timer T1 is cancelled after some pre-determined number of 
>   expirations (which MAY be 1). (By this time any existing adjacency 
>   on a remote system would probably have expired anyway.) 
> 
> 
>Shand, Ginsberg            Expires Apr 2004                   [Page 9] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>3.3.2       Adjacency acquisition during start 
>
>   The starting router wants to ensure that in the event a neighboring 
>   router has an adjacency to the starting router in the UP state (from 
>   a previous incarnation of the starting router) that this adjacency 
>   is reinitialized. The starting router also wants neighboring routers 
>   to suppress advertisement of an adjacency to the starting router 
>   until LSP database synchronization is achieved. This is achieved by 
>   sending IIHs with the RR bit clear and the SA bit set in the restart 
>   TLV. The RR bit remains clear and the SA bit remains set in 
>   subsequent transmissions of IIHs until the adjacency has reached the 
>   UP state and the initial T1 timer interval (see below) has expired. 
>
>   Receipt of an IIH with RR bit clear will result in the neighboring 
>   router utilizing normal operation of the adjacency state machine. 
>   This will ensure that any old adjacency on the neighboring router 
>   will be reinitialized. 
>
>   On receipt of an IIH with SA bit set the behavior described in 3.2.2 
>   is followed.  
>
>   On starting, a router starts timer T2 for each LSPDB. 
>
>   For each interface (and in the case of a LAN circuit, for each 
>   level), when an adjacency reaches the UP state, the starting router 
>   starts a timer T1 and transmits an IIH containing the restart TLV 
>   with the RR bit clear and SA bit set. On expiry of the timer T1, it 
>   is restarted and the IIH is retransmitted with both RR and SA bits 
>   set (only the RR bit has changed state from earlier IIHs). 
>
>   On receipt of an IIH with RR bit set (regardless of whether SA is 
>   set or not) the behavior described in 3.2.1 is followed.  
>
>   When an IIH is received by the starting router and the IIH contains 
>   a restart TLV with the RA bit set (and on LAN circuits with a 
>   Restart Neighbor System ID which matches that of the local system), 
>   the receipt of the acknowledgement over that interface is noted. 
>
>   On a Point-to-Point link, receipt of an IIH not containing the 
>   restart TLV is also treated as an acknowledgement, since it 
>   indicates that the neighbor is not restart capable. Since the 
>   neighbor will have reinitialized the adjacency this guarantees that 
>   SRMflags have been set on its database, thus ensuring eventual LSPDB 
>   synchronization. However, since no CSNP is guaranteed to be received 
>   over this interface, the timer T1 is cancelled immediately without 
>   waiting for a complete set of CSNP(s). Synchronization may therefore 
>   be deemed complete even though there are some LSPs which are held 
>   (only) by this neighbor (see section 4.4).  
>
>
> 
> 
>Shand, Ginsberg            Expires Apr 2004                  [Page 10] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>   In the case of a LAN interface, receipt of an IIH not containing the 
>   restart TLV is unremarkable since synchronization can still occur so 
>   long as at least one of the non-restarting neighboring routers on 
>   the LAN supports restart. Therefore T1 continues to run in this 
>   case. If none of the neighbors on the LAN are restart capable, T1 
>   will eventually expire after the locally defined number of retries. 
>   The usual operation of the update process will ensure that 
>   synchronization is eventually achieved. 
>
>   When BOTH a complete set of CSNP(s) (for each active level, in the 
>   case of a pt-pt circuit) and an acknowledgement have been received 
>   over the interface, the timer T1 is cancelled. Subsequent IIHs sent 
>   by the starting router have the RR and RA bits clear and the SA bit 
>   set in the restart TLV. 
>
>   Timer T1 is cancelled after some pre-determined number of 
>   expirations (which MAY be 1).  
>
>   When the T2 timer(s) are cancelled or expire transmission of 
>   "normal" IIHs (with RR, RA, and SA bits clear) will begin. 
>
>3.3.3       Multiple levels 
>
>   A router which is operating as both a Level 1 and a Level 2 router 
>   on a particular interface MUST perform the above operations for each 
>   level. 
>
>   On a LAN interface, it MUST send and receive both Level 1 and 
>   Level 2 IIHs and perform the CSNP synchronizations independently for 
>   each level. 
>
>   On a pt-pt interface, only a single IIH (indicating support for both 
>   levels) is required, but it MUST perform the CSNP synchronizations 
>   independently for each level. 
>
>3.4     Database synchronization 
>
>   When a router is started or restarted it can expect to receive a 
>   (set of) CSNP(s) over each interface. The arrival of the CSNP(s) is 
>   now guaranteed, since an IIH with RR bit set will be retransmitted 
>   until the CSNP(s) are correctly received. 
>
>   The CSNPs describe the set of LSPs that are currently held by each 
>   neighbor. Synchronization will be complete when all these LSPs have 
>   been received. 
>
>   When (re)starting, a router starts an instance of timer T2 for each 
>   LSPDB as described in 4.3.1 or 4.3.2. In addition to normal 
>   processing of the CSNPs, the set of LSPIDs contained in the first 
>   complete set of CSNP(s) received over each interface is recorded, 
> 
> 
>Shand, Ginsberg            Expires Apr 2004                  [Page 11] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>   together with their remaining lifetime. In the case of a LAN 
>   interface, a complete set of CSNPs MUST consist of CSNPs received 
>   from neighbor(s) which are not restarting. If there are multiple 
>   interfaces on the (re)starting router, the recorded set of LSPIDs is 
>   the union of those received over each interface. LSPs with a 
>   remaining lifetime of zero are NOT so recorded. 
>
>   As LSPs are received (by the normal operation of the update process) 
>   over any interface, the corresponding LSPID entry is removed (it is 
>   also removed if the LSP had arrived before the CSNP containing the 
>   reference). When an LSPID has been held in the list for its 
>   indicated remaining lifetime, it is removed from the list. When the 
>   list of LSPIDs is empty and the timer T1 has been cancelled for all 
>   the interfaces that have an adjacency at this level, the timer T2 is 
>   cancelled. 
>
>   At this point the local database is guaranteed to contain all the 
>   LSP(s) (either the same sequence number, or a more recent sequence 
>   number) which were present in the neighbors' databases at the time 
>   of (re)starting. LSPs that arrived in a neighbor's database after 
>   the time of (re)starting may or may not be present, but the normal 
>   operation of the update process will guarantee that they will 
>   eventually be received. At this point the local database is deemed 
>   to be "synchronized". 
>
>   Since LSPs mentioned in the CSNP(s) with a zero remaining lifetime 
>   are not recorded, and those with a short remaining lifetime are 
>   deleted from the list when the lifetime expires, cancellation of the 
>   timer T2 will not be prevented by waiting for an LSP that will never 
>   arrive. 
>
>3.4.1       LSP generation and flooding and SPF computation 
>
>   The operation of a router starting, as opposed to restarting is 
>   somewhat different. These two cases are dealt with separately below. 
>
>    
>
>3.4.1.1.          Restarting 
>
>   In order to avoid causing unnecessary routing churn in other 
>   routers, it is highly desirable that the own LSPs generated by the 
>   restarting system are the same as those previously present in the 
>   network (assuming no other changes have taken place). It is 
>   important therefore not to regenerate and flood the LSPs until all 
>   the adjacencies have been re-established and any information 
>   required for propagation into the local LSPs is fully available. 
>   Ideally, the information is loaded into the LSPs in a deterministic 
>   way, such that the same information occurs in the same place in the 
>   same LSP (and hence the LSPs are identical to their previous 
> 
> 
>Shand, Ginsberg            Expires Apr 2004                  [Page 12] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>   versions). If this can be achieved, the new versions will not even 
>   cause SPF to be run in other systems. However, provided the same 
>   information is included in the set of LSPs (albeit in a different 
>   order, and possibly different LSPs), the result of running the SPF 
>   will be the same and will not cause churn to the forwarding tables. 
>
>   In the case of a restarting router, none of the router's own LSPs 
>   are transmitted, nor are the router's own forwarding tables updated 
>   while the timer T3 is running. 
>
>   Redistribution of inter-level information MUST be regenerated before 
>   this router's LSP is flooded to other nodes. Therefore the Level-n 
>   non-pseudonode LSP(s) MUST NOT be flooded until the other level's T2 
>   timer has expired and its SPF has been run. This ensures that any 
>   inter-level information which is to be propagated can be included in 
>   the Level-n LSP(s).  
>
>   During this period, if one of the router's own (including 
>   pseudonodes) LSPs is received, which the local router does not 
>   currently have in its own database, it is NOT purged. Under normal 
>   operation, such an LSP would be purged, since the LSP clearly should 
>   not be present in the global LSP database. However, in the present 
>   circumstances, this would be highly undesirable, because it could 
>   cause premature removal of an own LSP - and hence churn in remote 
>   routers. Even if the local system has one or more own LSPs (which it 
>   has generated, but not yet transmitted) it is still not valid to 
>   compare the received LSP against this set, since it may be that as a 
>   result of propagation between Level 1 and Level 2 (or vice versa) a 
>   further own LSP will need to be generated when the LSP databases 
>   have synchronized. 
>
>   During this period a restarting router SHOULD send CSNPs as it 
>   normally would. Information about the router's own LSPs MAY be 
>   included, but if it is included it MUST be based on LSPs which have 
>   been received, not on versions which have been generated (but not 
>   yet transmitted). This restriction is necessary to prevent premature 
>   removal of an LSP from the global LSP database.  
>
>   When the timer T2 expires or is cancelled indicating that 
>   synchronization for that level is complete, the SPF for that level 
>   is run in order to derive any information which is required to be 
>   propagated to another level, but the forwarding tables are not yet 
>   updated.   
>
>   Once the other level's SPF has run and any inter-level propagation 
>   has been resolved, the 'own' LSPs can be generated and flooded. Any 
>   'own' LSPs which were previously ignored, but which are not part of 
>   the current set of 'own' LSPs (including pseudonodes) MUST then be 
>   purged. Note that it is possible that a Designated Router change may 
>   have taken place, and consequently the router SHOULD purge those 
> 
> 
>Shand, Ginsberg            Expires Apr 2004                  [Page 13] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>   pseudonode LSPs which it previously owned, but which are now no 
>   longer part of its set of pseudonode LSPs. 
>
>   When all the T2 timers have expired or been cancelled, the timer T3 
>   is cancelled and the local forwarding tables are updated. 
>
>   If the timer T3 expires before all the T2 timers have expired or 
>   been cancelled, this indicates that the synchronization process is 
>   taking longer than minimum holding time of the neighbors. The 
>   router's own LSP(s) for levels which have not yet completed their 
>   first SPF computation are then flooded with the overload bit set to 
>   indicate that the router's LSPDB is not yet synchronized (and 
>   therefore other routers MUST NOT compute routes through this 
>   router). Normal operation of the update process resumes and the 
>   local forwarding tables are updated. In order to prevent the 
>   neighbor's adjacencies from expiring, IIHs with the normal interface 
>   value for the holding time are transmitted over all interfaces with 
>   neither RR nor RA set in the restart TLV. This will cause the 
>   neighbors to refresh their adjacencies. The own LSP(s) will continue 
>   to have the overload bit set until timer T2 has expired or been 
>   cancelled.  
>
>3.4.1.2.          Starting 
>
>   In the case of a starting router, as soon as each adjacency is 
>   established, and before any CSNP exchanges, the router's own zeroth 
>   LSP is transmitted with the overload bit set. This prevents other 
>   routers from computing routes through the router until it has 
>   reliably acquired the complete set of LSPs. The overload bit remains 
>   set in subsequent transmissions of the zeroth LSP (such as will 
>   occur if a previous copy of the routers LSP is still present in the 
>   network) while any timer T2 is running. 
>
>   When all the T2 timers have been cancelled, the own LSP(s) MAY be 
>   regenerated with the overload bit clear (assuming the router isn't 
>   in fact overloaded, and there is no other reason, such as incomplete 
>   BGP convergence, to keep the overload bit set), and flooded as 
>   normal. 
>
>   Other 'own' LSPs (including pseudonodes) are generated and flooded 
>   as normal, irrespective of the timer T2. The SPF is also run as 
>   normal and the RIB and FIB updated as routes become available. 
>
>   To avoid the possible formation of temporary blackholes the starting 
>   router sets the SA bit in the restart TLV (as described in 4.3.2) in 
>   all IIHs that it sends. 
>
>   When all T2 timers have been cancelled the starting router MUST 
>   transmit IIHs with the SA bit clear. 
>
> 
> 
>Shand, Ginsberg            Expires Apr 2004                  [Page 14] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>    
>
>4.    State Tables 
>
>   This section presents state tables which summarize the behaviors 
>   described in this document. Other behaviors, in particular adjacency 
>   state transitions and LSP database update operation, are NOT 
>   included in the state tables except where this document modifies the 
>   behaviors described in [3] and [5]. 
>
>   Three state tables are presented from the point of view of a running 
>   router, a restarting router, and a starting router. 
>
>    
>
>4.1     Running Router 
>
>  Event       | Running              | ADJ suppressed  
> ============================================================== 
>  RX RR       | Maintain ADJ State   | 
>              | Send RA              | 
>              | Set SRM,send CSNP    | 
>              |  (Note 1)            | 
>              | Update Hold Time,    | 
>              |  set Restart Mode    | 
>              |  (Note 2)            | 
> -------------+----------------------+------------------------- 
>  RX RR clr   | Clr Restart mode     | 
> -------------+----------------------+------------------------- 
>  RX SA set   | Suppress IS neighbor | 
>              |   TLV in LSP(s)      | 
>              | Goto ADJ Suppressed  | 
> -------------+----------------------+------------------------- 
>  RX SA clr   |                      |Unsuppress IS neighbor 
>              |                      |   TLV in LSP(s) 
>              |                      |Goto Running 
> ============================================================== 
>  
>    Note 1: If ADJ is UP 
>    Note 2: If Restart Mode clear 
>
>
>
>
>
>
>
> 
> 
>Shand, Ginsberg            Expires Apr 2004                  [Page 15] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>     
>4.2     Restarting Router 
>
>  Event      | Restarting         | ADJ Seen  | ADJ Seen  | SPF Wait 
>             |                    |    RA     |   CSNP    | 
> =================================================================== 
>  Router     | Send IIH/RR        |           |           | 
>   restarts  | ADJ Init           |           |           | 
>             | Start T1,T2,T3     |           |           | 
> ------------+--------------------+-----------+-----------+------------ 
>  RX RR      | Send RA            |           |           | 
> ------------+--------------------+-----------+-----------+------------ 
>  RX RA      | Adjust T3          |           | Cancel T1 | 
>             | Goto ADJ Seen RA   |           | Adjust T3 | 
> ----------- +--------------------+-----------+-----------+------------ 
>  RX CSNP    | Goto ADJ Seen CSNP | Cancel T1 |           | 
> ------------+--------------------+-----------+-----------+------------ 
>  RX IIH w/o | Cancel T1          |           |           | 
>  Restart TLV|                    |           |           | 
> ------------+--------------------+-----------+-----------+------------ 
>  T1 Expires | Send IIH/RR        |Send IIH/RR|Send IIH/RR| 
>             | Restart T1         | Restart T1| Restart T1| 
> ------------+--------------------+-----------+-----------+------------ 
>  T1 Expires | Send IIH/          | Send IIH/ | Send IIH/ | 
>   nth time  |   normal           |   normal  |   normal  | 
> ------------+--------------------+-----------+-----------+------------ 
>  T2 expires | Trigger SPF        |           |           | 
>             | Goto SPF Wait      |           |           | 
> ------------+--------------------+-----------+-----------+------------ 
>  T3 expires | Set OL             |           |           | 
>             | Flood local LSPs   |           |           | 
>             | Update fwd plane   |           |           | 
> ------------+--------------------+-----------+-----------+------------ 
>  LSP DB Sync| Cancel T2, and T3  |           |           | 
>             | Trigger SPF        |           |           | 
>             | Goto SPF wait      |           |           | 
> ------------+--------------------+-----------+-----------+------------ 
> All SPF     |                    |           |           | Clear OL 
>   done      |                    |           |           | Update fwd 
>             |                    |           |           |  plane 
>             |                    |           |           | Flood local 
>             |                    |           |           |   LSPs 
>             |                    |           |           | Goto Runing 
> ====================================================================== 
> 
> 
>Shand, Ginsberg            Expires Apr 2004                  [Page 16] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>    
>4.3     Starting Router 
>
>  Event       | Starting          | ADJ Seen RA| ADJ Seen CSNP  
> ============================================================= 
> Router       | Send IIH/SA       |            |                
>   starts     | Start T1,T2       |            |                
> -------------+-------------------+------------+--------------- 
> RX RR        | Send RA           |            | 
> -------------+-------------------+------------+--------------- 
> RX RA        | Goto ADJ Seen RA  |            | Cancel T1 
> -------------+-------------------+------------+--------------- 
> RX CSNP Set  | Goto ADJ Seen CSNP| Cancel T1  |                
> -------------+-------------------+------------+--------------- 
> RX IIH w     | Cancel T1         |            |                
>   no Restart |                   |            |                
>   TLV        |                   |            |                
> -------------+-------------------+------------+--------------- 
> ADJ UP       | Start T1          |            |                
>              | Send local LSPs   |            |                
>              |  w OL             |            |                
> -------------+-------------------+------------+--------------- 
> T1 Expires   | Send IIH/RR       |Send IIH/RR | Send IIH/RR    
>              |   and SA          |   and SA   |   and SA       
>              | Restart T1        |Restart T1  | Restart T1     
> -------------+-------------------+------------+--------------- 
> T1 Expires   | Send IIH/SA       |Send IIH/SA | Send IIH/SA    
>  nth time    |                   |            |                
> -------------+-------------------+------------+--------------- 
> T2 expires   | Clear OL          |            |                
>              | Send IIH normal   |            |                
>              | Goto Running      |            |                
> -------------+-------------------+------------+--------------- 
> LSP DB Sync  | Cancel T2         |            |                
>              | Clear OL          |            |                
>              | Send IIH normal   |            |                
> ============================================================== 
>
>
>
>
>
>
>
>
> 
> 
>Shand, Ginsberg            Expires Apr 2004                  [Page 17] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>     
>    
>
>5.    Security Considerations 
>
>   This memo does not create any new security issues for the IS-IS 
>   protocol. Security considerations for the base IS-IS protocol are 
>   covered in [2] and [3]. 
>
>6.    Normative References 
>
>   1 Bradner, S., "The Internet Standards Process -- Revision 3", BCP 
>     9, RFC 2026, October 1996.  
>
>   2 Callon, R., "OSI IS-IS for IP and Dual Environment," RFC 1195, 
>     December 1990.  
>
>   3 ISO, "Intermediate system to Intermediate system routeing 
>     information exchange protocol for use in conjunction with the 
>     Protocol for providing the Connectionless-mode Network Service 
>     (ISO 8473)," ISO/IEC 10589:2002, Second Edition.  
>
>   4 Bradner, S., "Key words for use in RFCs to Indicate Requirement 
>     Levels", BCP 14, RFC 2119, March 1997  
>
>   5 Katz, D., "Three-Way Handshake for IS-IS Point-to-Point 
>     Adjacencies", RFC 3373, September 2002 
>
>7.    Acknowledgments 
>
>   The authors would like to acknowledge contributions made by Jeff 
>   Parker, Radia Perlman, Mark Schaefer, Naiming Shen, Nischal Sheth, 
>   Russ White, and Rena Yang. 
>
>8.    Authors' Addresses 
>
>   Mike Shand 
>   Cisco Systems 
>   250 Longwater Avenue, 
>   Reading, 
>   Berkshire, 
>   RG2 6GB 
>   UK 
>   Phone: +44 208 824 8690 
>   Email: [email-masked] 
>
>    
>   Les Ginsberg 
>   Cisco Systems 
>   510 McCarthy Blvd. 
> 
> 
>Shand, Ginsberg            Expires Apr 2004                  [Page 18] 
> 
> 
>INTERNET DRAFT              IS-IS restart                    Oct 2003 
> 
> 
>   Milpitas, Ca. 95035 USA 
>   Email: [email-masked] 
>    
>
>9.    Full Copyright Statement 
>
>   Copyright (C) The Internet Society (2003).  All Rights Reserved. 
>
>   This document and translations of it may be copied and furnished to 
>   others, and derivative works that comment on or otherwise explain it 
>   or assist in its implementation may be prepared, copied, published 
>   and distributed, in whole or in part, without restriction of any 
>   kind, provided that the above copyright notice and this paragraph 
>   are included on all such copies and derivative works.  However, this 
>   document itself may not be modified in any way, such as by removing 
>   the copyright notice or references to the Internet Society or other 
>   Internet organizations, except as needed for the purpose of 
>   developing Internet standards in which case the procedures for 
>   copyrights defined in the Internet Standards process must be 
>   followed, or as required to translate it into languages other than 
>   English. 
>
>   The limited permissions granted above are perpetual and will not be 
>   revoked by the Internet Society or its successors or assigns. 
>
>   This document and the information contained herein is provided on an 
>   "AS IS" basis and THE INTERNET SOCIETY AND THE INTERNET ENGINEERING 
>   TASK FORCE DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING 
>   BUT NOT LIMITED TO ANY WARRANTY THAT THE USE OF THE INFORMATION 
>   HEREIN WILL NOT INFRINGE ANY RIGHTS OR ANY IMPLIED WARRANTIES OF 
>   MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
>
> 
> 
>Shand, Ginsberg            Expires Apr 2004                  [Page 19] 
> 
>

---

From: Les Ginsberg <[email-masked]>
Date: Tue, 04 Nov 2003 14:18:09 -0800

Acee -

At 02:35 PM 11/4/2003 -0500, Acee Lindem wrote:
>>It appears that you are looking at V4 of the draft, which is the last one 
>>that was posted. However, we prepared V5 of the draft which is purely an 
>>editorial revision precisely to address the "nits". It also includes some 
>>minor changes regarding SA bit handling by the receiver that were 
>>requested by Tony P. in his review. Apparently no one forwarded V5 to you 
>>(it has not been publicly posted yet). I have attached it. (Apologies to 
>>those who already have it.)
>>
>>>been years since I've read the base IS-IS specifications so please bear 
>>>with my questions.
>>>
>>>First Nits:
>>>
>>>   - Abstracts are not supposed to contain any [] references since they 
>>> are often excerpted.  You'll
>>>         extensions is detected by the restarting router - couldn't this 
>>> potentially cause a routing
>>I don't think so - at least not persistent ones. In order for a loop to 
>>occur, a router would have to compute a path via a non-restart 
>>>         had lost synchronization?  I looked at IOS 9542 and didn't find 
>>> anything.
>>
>>
>>adjacency reach UP state which only requires hello exchange. Subsequent 
>>to that database synchronization occurred. See 7.3.7 and the state tables 
>>in Section 8.
>>
>>I am not sure what you mean here by "lost synchronization". The SA bit is 
>>used to suppress neighbor advertisement until synchronization has been 
>>achieved. It's not used to respond to lost synchronization.
>

The SA bit is only used by a starting router - not by a restarting router. 
The purpose of the SA bit is to prevent temporary blackholes that may occur 
because stale copies of the starting router's LSPs (from a previous 
incarnation) may exist in the network. Until the starting router has a 
chance to sync it's LSP database and - if necessary- flood new copies of 
the stale LSPs - other routers might compute paths to destinations 
advertised in the stale LSPs. By having neighbors suppress the 
advertisement of an adjacency to the starting router the two way 
connectivity check will prevent such blackholes from occurring.

Section 3.2.2 describes this best.

In its own way, think of this has the equivalent of OSPF requiring database 
sync to be completed before an adjacency can be advertised (a mechanism 
base IS-IS does not have). The difference here is that in OSPF sync is 
declared on a neighbor by neighbor basis, whereas we declare sync after we 
have synced with all our neighbors (or T2 expires).

Hope that helps.

     Les

---

From: Christian Hopps <[email-masked]>
Date: Thu, 6 Nov 2003 10:03:14 -0800

On Nov 3, 2003, at 2:11 PM, Acee Lindem wrote:

> subject document.

My previous private comments have been dealt with in these newer
drafts, so I'll just stick to new comments here, all of which
are editorial in nature.

Comments inline.

> [...]
> [...]

These two paragraphs seem clunky. At first I thought it was a
repeat paragraph mistake. Perhaps not having the same 6 words
start the second paragraph would help, or maybe it's just me.

> [...]

I think you should illustrate the entire TLV in the "bits" format.

  0                   1                   2                   3
  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |  Type = 211   |    Length     |     Flags     | Remaining...  |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  | ...Time(*)    |  Restarting Neighbor System ID (**) ...
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

keeping the breakout detail of the Flags field as well.

Aside from this just being standard, it also avoids confusion such

>          Length 1 - (3 + ID Length)

Which really meant 1 octet of length which is 3 + ID Length, the
use of "-" is confusing here. :)

Additionally I wouldn't specify the formula for the length as
you have since it depends on what is included. I say leave out the
formula, just describe what goes in the TLV.

>   Event       | Running              | ADJ suppressed

Nit, you specify SA "set" but not RR "set".

>   Event      | Restarting         | ADJ Seen  | ADJ Seen  | SPF Wait

This is for P2P only right, if so please add that.

Same comment as with restarting FSM.

That's it.

Thanks,
Chris.

---

From: Les Ginsberg <[email-masked]>
Date: Thu, 06 Nov 2003 23:28:43 -0800

Chris -

Replies inline.

>start the second paragraph would help, or maybe it's just me.

No, I don't think it's just you. I remember struggling with this way back 
when. How about condensing into one paragraph which reads:

    "This draft additionally describes a mechanism for a restarting
    router to determine when it has achieved LSP database
    synchronization with its neighbors and a mechanism to optimize LSP
    database synchronization and minimize transient routing disruption
    when a router starts. "

??

>I think you should illustrate the entire TLV in the "bits" format.

No. That is not correct. What is included in the TLV is:

1 byte flags  (Always)
2 bytes of remaining hold time (only when RA is set)
ID length bytes of restarting neighbor system ID (only when RA is set)

In addition, because earlier versions of the draft did not include the 
restarting neighbor system ID (it was a loophole we only discovered prior 
to V4) it's possible that an implementation may send the hold time but not 
the system ID. So the number of bytes in the TLV could be:

1 (when RA is not set)
3 (RA set - implementation based on V3 draft or earlier)
9 (RA set - implementation based on V4 or later)

While I appreciate your attempts to standardize TLV presentation, I am not 
so sure the 32 bit picture format makes things clearer in this instance due 
to the byte oriented nature of most of the info and the variable number of 
bytes which may be included. I would rather leave the picture as it is, but 
if I get outvoted I am willing to concede.

>Nit, you specify SA "set" but not RR "set".

OK. I'll make these consistent.

>This is for P2P only right, if so please add that.

Nope. Works the same on a LAN.

>Same comment as with restarting FSM.

OK.

>Chris.

Thank you.

    Les

---

From: Christian Hopps <[email-masked]>
Date: Fri, 7 Nov 2003 00:08:24 -0800

>     database synchronization and minimize transient routing disruption

That's much better IMO.

> ID length bytes of restarting neighbor system ID (only when RA is set)

Yes, I understand that. I was just interpreting what
"1 - (3 + ID Length)" was supposed to mean in your draft,
and not what the length value actually should be set to. Indeed
the fact that (3 + ID Length) doesn't correctly describe the
length was my point about leaving off the formula altogether.

> if I get outvoted I am willing to concede.

Its just the standard form. The main reason for using something similar
to my picture is to indicate the on-wire placement. I don't have a
strong opinion here, its just what I was told by the ADs on my
IS-IS draft. :)

>>>  -----------  
>>> +--------------------+-----------+-----------+------------

Hmmm. To quote your draft (from 3.3.1):

Which to me indicates that for LAN you do *not* cancel T1.

Thanks,
Chris.

>>>    done      |                    |           |           | Update  
>>> fwd
>>>              |                    |           |           | Flood  
>>> local
>>>              |                    |           |           | Goto  
>>> Runing

---

From: Les Ginsberg <[email-masked]>
Date: Fri, 07 Nov 2003 08:25:02 -0800

Chris -

>length was my point about leaving off the formula altogether.

Hmmm...struggling a bit to understand your objection. You don't the like 
the use of "-" as it appears to imply an arithmetic computation?? If so, 
then how about:

Length   Total length of the value field (1 to (3 + ID length) octets)

??

>strong opinion here, its just what I was told by the ADs on my

Understood. I'll go with the majority opinion here - whatever that is.

>>>>------------+--------------------+-----------+----------- +------------
>>>>   RX RR      | Send RA            |           |           |
>>>>
>>>>------------+--------------------+-----------+----------- +------------
>>>>------------+--------------------+-----------+----------- +------------

Ahhh. Well spotted! I didn't look closely enough at the specific line you 
were pointing at. I'll correct that.

>Chris.

Thanx again.

    Les

---

From: Christian Hopps <[email-masked]>
Date: Fri, 7 Nov 2003 10:13:22 -0800

On Nov 7, 2003, at 8:25 AM, Les Ginsberg wrote:
> Hmmm...struggling a bit to understand your objection. You don't the 
> like the use of "-" as it appears to imply an arithmetic computation?? 
> If so, then how about:
>

Oh '-' meant "to". Yes I suppose I object to that (since it took me
2 tries to even get it :).

I really don't see the need to specify the length bounds.
"Length of the value field in octets" seems fine to me, but
whatever.

Thanks,
Chris.

---

From: Alex Zinin <[email-masked]>
Date: Sun, 9 Nov 2003 12:08:36 -0600

Les, Chris

> Understood. I'll go with the majority opinion here - whatever that is.

This used to be the piece we would check during the AD-review and
push for a standard IETF format. The recent agreement was to leave
this to the RFC editor team to push back on. The recommendation is
to either use the standard IETF representation or the one used
in RFC 1195.

Alex

---

From: Les Ginsberg <[email-masked]>
Date: Mon, 10 Nov 2003 21:17:44 -0800

>to either use the standard IETF representation or the one used

I have opted for the RFC 1195 format. :-)

Attached is new version which I think incorporates all comments. (and diffs)

Let me know if there are any more issues.

Thanx.

     Les